diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/plugin-install.php ./wordpress-3.4/wp-admin/includes/plugin-install.php
*** ./wordpress-3.3.2/wp-admin/includes/plugin-install.php	2011-11-01 23:14:14.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/plugin-install.php	2012-05-09 11:27:24.000000000 -0500
***************
*** 43,53 ****
  	if ( false === $res ) {
  		$request = wp_remote_post('http://api.wordpress.org/plugins/info/1.0/', array( 'timeout' => 15, 'body' => array('action' => $action, 'request' => serialize($args))) );
  		if ( is_wp_error($request) ) {
! 			$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.'), $request->get_error_message() );
  		} else {
! 			$res = unserialize( wp_remote_retrieve_body( $request ) );
! 			if ( false === $res )
! 				$res = new WP_Error('plugins_api_failed', __('An unknown error occurred.'), wp_remote_retrieve_body( $request ) );
  		}
  	} elseif ( !is_wp_error($res) ) {
  		$res->external = true;
--- 43,53 ----
  	if ( false === $res ) {
  		$request = wp_remote_post('http://api.wordpress.org/plugins/info/1.0/', array( 'timeout' => 15, 'body' => array('action' => $action, 'request' => serialize($args))) );
  		if ( is_wp_error($request) ) {
! 			$res = new WP_Error('plugins_api_failed', __( 'An unexpected error occurred. Something may be wrong with WordPress.org or this server&#8217;s configuration. If you continue to have problems, please try the <a href="http://wordpress.org/support/">support forums</a>.' ), $request->get_error_message() );
  		} else {
! 			$res = maybe_unserialize( wp_remote_retrieve_body( $request ) );
! 			if ( ! is_object( $res ) && ! is_array( $res ) )
! 				$res = new WP_Error('plugins_api_failed', __( 'An unexpected error occurred. Something may be wrong with WordPress.org or this server&#8217;s configuration. If you continue to have problems, please try the <a href="http://wordpress.org/support/">support forums</a>.' ), wp_remote_retrieve_body( $request ) );
  		}
  	} elseif ( !is_wp_error($res) ) {
  		$res->external = true;
***************
*** 84,91 ****
  	<p><?php printf( __( 'Plugins extend and expand the functionality of WordPress. You may automatically install plugins from the <a href="http://wordpress.org/extend/plugins/">WordPress Plugin Directory</a> or upload a plugin in .zip format via <a href="%s">this page</a>.' ), self_admin_url( 'plugin-install.php?tab=upload' ) ); ?></p>
  
  	<h4><?php _e('Search') ?></h4>
! 	<p class="install-help"><?php _e('Search for plugins by keyword, author, or tag.') ?></p>
! 	<?php install_search_form(); ?>
  
  	<h4><?php _e('Popular tags') ?></h4>
  	<p class="install-help"><?php _e('You may also browse based on the most popular tags in the Plugin Directory:') ?></p>
--- 84,90 ----
  	<p><?php printf( __( 'Plugins extend and expand the functionality of WordPress. You may automatically install plugins from the <a href="http://wordpress.org/extend/plugins/">WordPress Plugin Directory</a> or upload a plugin in .zip format via <a href="%s">this page</a>.' ), self_admin_url( 'plugin-install.php?tab=upload' ) ); ?></p>
  
  	<h4><?php _e('Search') ?></h4>
! 	<?php install_search_form( false ); ?>
  
  	<h4><?php _e('Popular tags') ?></h4>
  	<p class="install-help"><?php _e('You may also browse based on the most popular tags in the Plugin Directory:') ?></p>
***************
*** 116,133 ****
   *
   * @since 2.7.0
   */
! function install_search_form(){
! 	$type = isset($_REQUEST['type']) ? stripslashes( $_REQUEST['type'] ) : '';
  	$term = isset($_REQUEST['s']) ? stripslashes( $_REQUEST['s'] ) : '';
  
  	?><form id="search-plugins" method="get" action="">
  		<input type="hidden" name="tab" value="search" />
  		<select name="type" id="typeselector">
! 			<option value="term"<?php selected('term', $type) ?>><?php _e('Term'); ?></option>
  			<option value="author"<?php selected('author', $type) ?>><?php _e('Author'); ?></option>
  			<option value="tag"<?php selected('tag', $type) ?>><?php _ex('Tag', 'Plugin Installer'); ?></option>
  		</select>
! 		<input type="text" name="s" value="<?php echo esc_attr($term) ?>" />
  		<label class="screen-reader-text" for="plugin-search-input"><?php _e('Search Plugins'); ?></label>
  		<?php submit_button( __( 'Search Plugins' ), 'button', 'plugin-search-input', false ); ?>
  	</form><?php
--- 115,134 ----
   *
   * @since 2.7.0
   */
! function install_search_form( $type_selector = true ) {
! 	$type = isset($_REQUEST['type']) ? stripslashes( $_REQUEST['type'] ) : 'term';
  	$term = isset($_REQUEST['s']) ? stripslashes( $_REQUEST['s'] ) : '';
  
  	?><form id="search-plugins" method="get" action="">
  		<input type="hidden" name="tab" value="search" />
+ 		<?php if ( $type_selector ) : ?>
  		<select name="type" id="typeselector">
! 			<option value="term"<?php selected('term', $type) ?>><?php _e('Keyword'); ?></option>
  			<option value="author"<?php selected('author', $type) ?>><?php _e('Author'); ?></option>
  			<option value="tag"<?php selected('tag', $type) ?>><?php _ex('Tag', 'Plugin Installer'); ?></option>
  		</select>
! 		<?php endif; ?>
! 		<input type="search" name="s" value="<?php echo esc_attr($term) ?>" />
  		<label class="screen-reader-text" for="plugin-search-input"><?php _e('Search Plugins'); ?></label>
  		<?php submit_button( __( 'Search Plugins' ), 'button', 'plugin-search-input', false ); ?>
  	</form><?php
***************
*** 167,173 ****
  add_action('install_plugins_featured', 'display_plugins_table');
  add_action('install_plugins_popular', 'display_plugins_table');
  add_action('install_plugins_new', 'display_plugins_table');
- add_action('install_plugins_updated', 'display_plugins_table');
  
  /**
   * Determine the status we can perform on a plugin.
--- 168,173 ----
***************
*** 185,191 ****
  
  	//Check to see if this plugin is known to be installed, and has an update awaiting it.
  	$update_plugins = get_site_transient('update_plugins');
! 	if ( is_object( $update_plugins ) ) {
  		foreach ( (array)$update_plugins->response as $file => $plugin ) {
  			if ( $plugin->slug === $api->slug ) {
  				$status = 'update_available';
--- 185,191 ----
  
  	//Check to see if this plugin is known to be installed, and has an update awaiting it.
  	$update_plugins = get_site_transient('update_plugins');
! 	if ( isset( $update_plugins->response ) ) {
  		foreach ( (array)$update_plugins->response as $file => $plugin ) {
  			if ( $plugin->slug === $api->slug ) {
  				$status = 'update_available';
***************
*** 199,205 ****
  	}
  
  	if ( 'install' == $status ) {
! 		if ( is_dir( WP_PLUGIN_DIR  . '/' . $api->slug ) ) {
  			$installed_plugin = get_plugins('/' . $api->slug);
  			if ( empty($installed_plugin) ) {
  				if ( current_user_can('install_plugins') )
--- 199,205 ----
  	}
  
  	if ( 'install' == $status ) {
! 		if ( is_dir( WP_PLUGIN_DIR . '/' . $api->slug ) ) {
  			$installed_plugin = get_plugins('/' . $api->slug);
  			if ( empty($installed_plugin) ) {
  				if ( current_user_can('install_plugins') )
***************
*** 245,256 ****
  	if ( is_wp_error($api) )
  		wp_die($api);
  
! 	$plugins_allowedtags = array('a' => array('href' => array(), 'title' => array(), 'target' => array()),
! 								'abbr' => array('title' => array()), 'acronym' => array('title' => array()),
! 								'code' => array(), 'pre' => array(), 'em' => array(), 'strong' => array(),
! 								'div' => array(), 'p' => array(), 'ul' => array(), 'ol' => array(), 'li' => array(),
! 								'h1' => array(), 'h2' => array(), 'h3' => array(), 'h4' => array(), 'h5' => array(), 'h6' => array(),
! 								'img' => array('src' => array(), 'class' => array(), 'alt' => array()));
  	//Sanitize HTML
  	foreach ( (array)$api->sections as $section_name => $content )
  		$api->sections[$section_name] = wp_kses($content, $plugins_allowedtags);
--- 245,268 ----
  	if ( is_wp_error($api) )
  		wp_die($api);
  
! 	$plugins_allowedtags = array(
! 		'a' => array( 'href' => array(), 'title' => array(), 'target' => array() ),
! 		'abbr' => array( 'title' => array() ), 'acronym' => array( 'title' => array() ),
! 		'code' => array(), 'pre' => array(), 'em' => array(), 'strong' => array(),
! 		'div' => array(), 'p' => array(), 'ul' => array(), 'ol' => array(), 'li' => array(),
! 		'h1' => array(), 'h2' => array(), 'h3' => array(), 'h4' => array(), 'h5' => array(), 'h6' => array(),
! 		'img' => array( 'src' => array(), 'class' => array(), 'alt' => array() )
! 	);
! 
! 	$plugins_section_titles = array(
! 		'description'  => _x('Description',  'Plugin installer section title'),
! 		'installation' => _x('Installation', 'Plugin installer section title'),
! 		'faq'          => _x('FAQ',          'Plugin installer section title'),
! 		'screenshots'  => _x('Screenshots',  'Plugin installer section title'),
! 		'changelog'    => _x('Changelog',    'Plugin installer section title'),
! 		'other_notes'  => _x('Other Notes',  'Plugin installer section title')
! 	);
! 
  	//Sanitize HTML
  	foreach ( (array)$api->sections as $section_name => $content )
  		$api->sections[$section_name] = wp_kses($content, $plugins_allowedtags);
***************
*** 268,281 ****
  	echo "<ul id='sidemenu'>\n";
  	foreach ( (array)$api->sections as $section_name => $content ) {
  
! 		$title = $section_name;
! 		$title = ucwords(str_replace('_', ' ', $title));
  
  		$class = ( $section_name == $section ) ? ' class="current"' : '';
  		$href = add_query_arg( array('tab' => $tab, 'section' => $section_name) );
  		$href = esc_url($href);
! 		$san_title = esc_attr(sanitize_title_with_dashes($title));
! 		echo "\t<li><a name='$san_title' target='' href='$href'$class>$title</a></li>\n";
  	}
  	echo "</ul>\n";
  	echo "</div>\n";
--- 280,295 ----
  	echo "<ul id='sidemenu'>\n";
  	foreach ( (array)$api->sections as $section_name => $content ) {
  
! 		if ( isset( $plugins_section_titles[ $section_name ] ) )
! 			$title = $plugins_section_titles[ $section_name ];
! 		else
! 			$title = ucwords( str_replace( '_', ' ', $section_name ) );
  
  		$class = ( $section_name == $section ) ? ' class="current"' : '';
  		$href = add_query_arg( array('tab' => $tab, 'section' => $section_name) );
  		$href = esc_url($href);
! 		$san_section = esc_attr( $section_name );
! 		echo "\t<li><a name='$san_section' href='$href' $class>$title</a></li>\n";
  	}
  	echo "</ul>\n";
  	echo "</div>\n";
***************
*** 322,339 ****
  <?php endif; if ( ! empty($api->slug) && empty($api->external) ) : ?>
  			<li><a target="_blank" href="http://wordpress.org/extend/plugins/<?php echo $api->slug ?>/"><?php _e('WordPress.org Plugin Page &#187;') ?></a></li>
  <?php endif; if ( ! empty($api->homepage) ) : ?>
! 			<li><a target="_blank" href="<?php echo $api->homepage ?>"><?php _e('Plugin Homepage  &#187;') ?></a></li>
  <?php endif; ?>
  		</ul>
  		<?php if ( ! empty($api->rating) ) : ?>
  		<h2><?php _e('Average Rating') ?></h2>
  		<div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?>">
! 			<div class="star star-rating" style="width: <?php echo esc_attr($api->rating) ?>px"></div>
! 			<div class="star star5"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('5 stars') ?>" /></div>
! 			<div class="star star4"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('4 stars') ?>" /></div>
! 			<div class="star star3"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('3 stars') ?>" /></div>
! 			<div class="star star2"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('2 stars') ?>" /></div>
! 			<div class="star star1"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('1 star') ?>" /></div>
  		</div>
  		<small><?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?></small>
  		<?php endif; ?>
--- 336,348 ----
  <?php endif; if ( ! empty($api->slug) && empty($api->external) ) : ?>
  			<li><a target="_blank" href="http://wordpress.org/extend/plugins/<?php echo $api->slug ?>/"><?php _e('WordPress.org Plugin Page &#187;') ?></a></li>
  <?php endif; if ( ! empty($api->homepage) ) : ?>
! 			<li><a target="_blank" href="<?php echo $api->homepage ?>"><?php _e('Plugin Homepage &#187;') ?></a></li>
  <?php endif; ?>
  		</ul>
  		<?php if ( ! empty($api->rating) ) : ?>
  		<h2><?php _e('Average Rating') ?></h2>
  		<div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?>">
! 			<div class="star star-rating" style="width: <?php echo esc_attr( str_replace( ',', '.', $api->rating ) ); ?>px"></div>
  		</div>
  		<small><?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?></small>
  		<?php endif; ?>
***************
*** 347,364 ****
  			echo '<div class="updated"><p>' . __('<strong>Warning:</strong> This plugin has <strong>not been marked as compatible</strong> with your version of WordPress.') . '</p></div>';
  
  		foreach ( (array)$api->sections as $section_name => $content ) {
! 			$title = $section_name;
! 			$title[0] = strtoupper($title[0]);
! 			$title = str_replace('_', ' ', $title);
  
  			$content = links_add_base_url($content, 'http://wordpress.org/extend/plugins/' . $api->slug . '/');
  			$content = links_add_target($content, '_blank');
  
! 			$san_title = esc_attr(sanitize_title_with_dashes($title));
  
  			$display = ( $section_name == $section ) ? 'block' : 'none';
  
! 			echo "\t<div id='section-{$san_title}' class='section' style='display: {$display};'>\n";
  			echo "\t\t<h2 class='long-header'>$title</h2>";
  			echo $content;
  			echo "\t</div>\n";
--- 356,375 ----
  			echo '<div class="updated"><p>' . __('<strong>Warning:</strong> This plugin has <strong>not been marked as compatible</strong> with your version of WordPress.') . '</p></div>';
  
  		foreach ( (array)$api->sections as $section_name => $content ) {
! 
! 			if ( isset( $plugins_section_titles[ $section_name ] ) )
! 				$title = $plugins_section_titles[ $section_name ];
! 			else
! 				$title = ucwords( str_replace( '_', ' ', $section_name ) );
  
  			$content = links_add_base_url($content, 'http://wordpress.org/extend/plugins/' . $api->slug . '/');
  			$content = links_add_target($content, '_blank');
  
! 			$san_section = esc_attr( $section_name );
  
  			$display = ( $section_name == $section ) ? 'block' : 'none';
  
! 			echo "\t<div id='section-{$san_section}' class='section' style='display: {$display};'>\n";
  			echo "\t\t<h2 class='long-header'>$title</h2>";
  			echo $content;
  			echo "\t</div>\n";
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/plugin.php ./wordpress-3.4/wp-admin/includes/plugin.php
*** ./wordpress-3.3.2/wp-admin/includes/plugin.php	2011-10-12 11:35:33.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/plugin.php	2012-04-20 19:45:53.000000000 -0500
***************
*** 65,72 ****
   * @since 1.5.0
   *
   * @param string $plugin_file Path to the plugin file
!  * @param bool $markup If the returned data should have HTML markup applied
!  * @param bool $translate If the returned data should be translated
   * @return array See above for description.
   */
  function get_plugin_data( $plugin_file, $markup = true, $translate = true ) {
--- 65,72 ----
   * @since 1.5.0
   *
   * @param string $plugin_file Path to the plugin file
!  * @param bool $markup Optional. If the returned data should have HTML markup applied. Defaults to true.
!  * @param bool $translate Optional. If the returned data should be translated. Defaults to true.
   * @return array See above for description.
   */
  function get_plugin_data( $plugin_file, $markup = true, $translate = true ) {
***************
*** 88,155 ****
  	$plugin_data = get_file_data( $plugin_file, $default_headers, 'plugin' );
  
  	// Site Wide Only is the old header for Network
! 	if ( empty( $plugin_data['Network'] ) && ! empty( $plugin_data['_sitewide'] ) ) {
  		_deprecated_argument( __FUNCTION__, '3.0', sprintf( __( 'The <code>%1$s</code> plugin header is deprecated. Use <code>%2$s</code> instead.' ), 'Site Wide Only: true', 'Network: true' ) );
  		$plugin_data['Network'] = $plugin_data['_sitewide'];
  	}
  	$plugin_data['Network'] = ( 'true' == strtolower( $plugin_data['Network'] ) );
  	unset( $plugin_data['_sitewide'] );
  
! 	//For backward compatibility by default Title is the same as Name.
! 	$plugin_data['Title'] = $plugin_data['Name'];
! 
! 	if ( $markup || $translate )
  		$plugin_data = _get_plugin_data_markup_translate( $plugin_file, $plugin_data, $markup, $translate );
! 	else
  		$plugin_data['AuthorName'] = $plugin_data['Author'];
  
  	return $plugin_data;
  }
  
! function _get_plugin_data_markup_translate($plugin_file, $plugin_data, $markup = true, $translate = true) {
! 
! 	//Translate fields
! 	if ( $translate && ! empty($plugin_data['TextDomain']) ) {
! 		if ( ! empty( $plugin_data['DomainPath'] ) )
! 			load_plugin_textdomain($plugin_data['TextDomain'], false, dirname($plugin_file). $plugin_data['DomainPath']);
! 		else
! 			load_plugin_textdomain($plugin_data['TextDomain'], false, dirname($plugin_file));
  
! 		foreach ( array('Name', 'PluginURI', 'Description', 'Author', 'AuthorURI', 'Version') as $field )
! 			$plugin_data[ $field ] = translate($plugin_data[ $field ], $plugin_data['TextDomain']);
  	}
  
! 	$plugins_allowedtags = array(
! 		'a'       => array( 'href' => array(), 'title' => array() ),
! 		'abbr'    => array( 'title' => array() ),
! 		'acronym' => array( 'title' => array() ),
! 		'code'    => array(),
! 		'em'      => array(),
! 		'strong'  => array(),
  	);
  
! 	$plugin_data['AuthorName'] = $plugin_data['Author'] = wp_kses( $plugin_data['Author'], $plugins_allowedtags );
  
! 	//Apply Markup
  	if ( $markup ) {
! 		if ( ! empty($plugin_data['PluginURI']) && ! empty($plugin_data['Name']) )
  			$plugin_data['Title'] = '<a href="' . $plugin_data['PluginURI'] . '" title="' . esc_attr__( 'Visit plugin homepage' ) . '">' . $plugin_data['Name'] . '</a>';
- 		else
- 			$plugin_data['Title'] = $plugin_data['Name'];
  
! 		if ( ! empty($plugin_data['AuthorURI']) && ! empty($plugin_data['Author']) )
  			$plugin_data['Author'] = '<a href="' . $plugin_data['AuthorURI'] . '" title="' . esc_attr__( 'Visit author homepage' ) . '">' . $plugin_data['Author'] . '</a>';
  
  		$plugin_data['Description'] = wptexturize( $plugin_data['Description'] );
- 		if ( ! empty($plugin_data['Author']) )
- 			$plugin_data['Description'] .= ' <cite>' . sprintf( __('By %s'), $plugin_data['Author'] ) . '.</cite>';
- 	}
  
! 	// Sanitize all displayed data. Author and AuthorName sanitized above.
! 	$plugin_data['Title']       = wp_kses( $plugin_data['Title'],       $plugins_allowedtags );
! 	$plugin_data['Version']     = wp_kses( $plugin_data['Version'],     $plugins_allowedtags );
! 	$plugin_data['Description'] = wp_kses( $plugin_data['Description'], $plugins_allowedtags );
! 	$plugin_data['Name']        = wp_kses( $plugin_data['Name'],        $plugins_allowedtags );
  
  	return $plugin_data;
  }
--- 88,172 ----
  	$plugin_data = get_file_data( $plugin_file, $default_headers, 'plugin' );
  
  	// Site Wide Only is the old header for Network
! 	if ( ! $plugin_data['Network'] && $plugin_data['_sitewide'] ) {
  		_deprecated_argument( __FUNCTION__, '3.0', sprintf( __( 'The <code>%1$s</code> plugin header is deprecated. Use <code>%2$s</code> instead.' ), 'Site Wide Only: true', 'Network: true' ) );
  		$plugin_data['Network'] = $plugin_data['_sitewide'];
  	}
  	$plugin_data['Network'] = ( 'true' == strtolower( $plugin_data['Network'] ) );
  	unset( $plugin_data['_sitewide'] );
  
! 	if ( $markup || $translate ) {
  		$plugin_data = _get_plugin_data_markup_translate( $plugin_file, $plugin_data, $markup, $translate );
! 	} else {
! 		$plugin_data['Title']      = $plugin_data['Name'];
  		$plugin_data['AuthorName'] = $plugin_data['Author'];
+ 	}
  
  	return $plugin_data;
  }
  
! /**
!  * Sanitizes plugin data, optionally adds markup, optionally translates.
!  *
!  * @since 2.7.0
!  * @access private
!  * @see get_plugin_data()
!  */
! function _get_plugin_data_markup_translate( $plugin_file, $plugin_data, $markup = true, $translate = true ) {
  
! 	// Translate fields
! 	if ( $translate ) {
! 		if ( $textdomain = $plugin_data['TextDomain'] ) {
! 			if ( $plugin_data['DomainPath'] )
! 				load_plugin_textdomain( $textdomain, false, dirname( $plugin_file ) . $plugin_data['DomainPath'] );
! 			else
! 				load_plugin_textdomain( $textdomain, false, dirname( $plugin_file ) );
! 		} elseif ( in_array( basename( $plugin_file ), array( 'hello.php', 'akismet.php' ) ) ) {
! 			$textdomain = 'default';
! 		}
! 		if ( $textdomain ) {
! 			foreach ( array( 'Name', 'PluginURI', 'Description', 'Author', 'AuthorURI', 'Version' ) as $field )
! 				$plugin_data[ $field ] = translate( $plugin_data[ $field ], $textdomain );
! 		}
  	}
  
! 	// Sanitize fields
! 	$allowed_tags = $allowed_tags_in_links = array(
! 		'abbr'    => array( 'title' => true ),
! 		'acronym' => array( 'title' => true ),
! 		'code'    => true,
! 		'em'      => true,
! 		'strong'  => true,
  	);
+ 	$allowed_tags['a'] = array( 'href' => true, 'title' => true );
+ 
+ 	// Name is marked up inside <a> tags. Don't allow these.
+ 	// Author is too, but some plugins have used <a> here (omitting Author URI).
+ 	$plugin_data['Name']        = wp_kses( $plugin_data['Name'],        $allowed_tags_in_links );
+ 	$plugin_data['Author']      = wp_kses( $plugin_data['Author'],      $allowed_tags );
  
! 	$plugin_data['Description'] = wp_kses( $plugin_data['Description'], $allowed_tags );
! 	$plugin_data['Version']     = wp_kses( $plugin_data['Version'],     $allowed_tags );
  
! 	$plugin_data['PluginURI']   = esc_url( $plugin_data['PluginURI'] );
! 	$plugin_data['AuthorURI']   = esc_url( $plugin_data['AuthorURI'] );
! 
! 	$plugin_data['Title']      = $plugin_data['Name'];
! 	$plugin_data['AuthorName'] = $plugin_data['Author'];
! 
! 	// Apply markup
  	if ( $markup ) {
! 		if ( $plugin_data['PluginURI'] && $plugin_data['Name'] )
  			$plugin_data['Title'] = '<a href="' . $plugin_data['PluginURI'] . '" title="' . esc_attr__( 'Visit plugin homepage' ) . '">' . $plugin_data['Name'] . '</a>';
  
! 		if ( $plugin_data['AuthorURI'] && $plugin_data['Author'] )
  			$plugin_data['Author'] = '<a href="' . $plugin_data['AuthorURI'] . '" title="' . esc_attr__( 'Visit author homepage' ) . '">' . $plugin_data['Author'] . '</a>';
  
  		$plugin_data['Description'] = wptexturize( $plugin_data['Description'] );
  
! 		if ( $plugin_data['Author'] )
! 			$plugin_data['Description'] .= ' <cite>' . sprintf( __('By %s.'), $plugin_data['Author'] ) . '</cite>';
! 	}
  
  	return $plugin_data;
  }
***************
*** 555,563 ****
   * @since 2.5.0
   *
   * @param string|array $plugins Single plugin or list of plugins to deactivate.
   * @param bool $silent Prevent calling deactivation hooks. Default is false.
   */
! function deactivate_plugins( $plugins, $silent = false ) {
  	if ( is_multisite() )
  		$network_current = get_site_option( 'active_sitewide_plugins', array() );
  	$current = get_option( 'active_plugins', array() );
--- 572,582 ----
   * @since 2.5.0
   *
   * @param string|array $plugins Single plugin or list of plugins to deactivate.
+  * @param mixed $network_wide Whether to deactivate the plugin for all sites in the network.
+  * 	A value of null (the default) will deactivate plugins for both the site and the network.
   * @param bool $silent Prevent calling deactivation hooks. Default is false.
   */
! function deactivate_plugins( $plugins, $silent = false, $network_wide = null ) {
  	if ( is_multisite() )
  		$network_current = get_site_option( 'active_sitewide_plugins', array() );
  	$current = get_option( 'active_plugins', array() );
***************
*** 568,582 ****
  		if ( ! is_plugin_active($plugin) )
  			continue;
  
! 		$network_wide = is_plugin_active_for_network( $plugin );
  
  		if ( ! $silent )
! 			do_action( 'deactivate_plugin', $plugin, $network_wide );
  
! 		if ( $network_wide ) {
! 			$do_network = true;
! 			unset( $network_current[ $plugin ] );
! 		} else {
  			$key = array_search( $plugin, $current );
  			if ( false !== $key ) {
  				$do_blog = true;
--- 587,607 ----
  		if ( ! is_plugin_active($plugin) )
  			continue;
  
! 		$network_deactivating = false !== $network_wide && is_plugin_active_for_network( $plugin );
  
  		if ( ! $silent )
! 			do_action( 'deactivate_plugin', $plugin, $network_deactivating );
  
! 		if ( false !== $network_wide ) {
! 			if ( is_plugin_active_for_network( $plugin ) ) {
! 				$do_network = true;
! 				unset( $network_current[ $plugin ] );
! 			} elseif ( $network_wide ) {
! 				continue;
! 			}
! 		}
! 
! 		if ( true !== $network_wide ) {
  			$key = array_search( $plugin, $current );
  			if ( false !== $key ) {
  				$do_blog = true;
***************
*** 585,592 ****
  		}
  
  		if ( ! $silent ) {
! 			do_action( 'deactivate_' . $plugin, $network_wide );
! 			do_action( 'deactivated_plugin', $plugin, $network_wide );
  		}
  	}
  
--- 610,617 ----
  		}
  
  		if ( ! $silent ) {
! 			do_action( 'deactivate_' . $plugin, $network_deactivating );
! 			do_action( 'deactivated_plugin', $plugin, $network_deactivating );
  		}
  	}
  
***************
*** 863,869 ****
   *
   * @return string The resulting page's hook_suffix
   */
! function add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function = '', $icon_url = '', $position = NULL ) {
  	global $menu, $admin_page_hooks, $_registered_pages, $_parent_pages;
  
  	$menu_slug = plugin_basename( $menu_slug );
--- 888,894 ----
   *
   * @return string The resulting page's hook_suffix
   */
! function add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function = '', $icon_url = '', $position = null ) {
  	global $menu, $admin_page_hooks, $_registered_pages, $_parent_pages;
  
  	$menu_slug = plugin_basename( $menu_slug );
***************
*** 882,888 ****
  
  	$new_menu = array( $menu_title, $capability, $menu_slug, $page_title, 'menu-top ' . $hookname, $hookname, $icon_url );
  
! 	if ( null === $position  )
  		$menu[] = $new_menu;
  	else
  		$menu[$position] = $new_menu;
--- 907,913 ----
  
  	$new_menu = array( $menu_title, $capability, $menu_slug, $page_title, 'menu-top ' . $hookname, $hookname, $icon_url );
  
! 	if ( null === $position )
  		$menu[] = $new_menu;
  	else
  		$menu[$position] = $new_menu;
***************
*** 985,994 ****
  	}
  
  	// If the parent doesn't already have a submenu, add a link to the parent
! 	// as the first item in the submenu.  If the submenu file is the same as the
! 	// parent file someone is trying to link back to the parent manually.  In
  	// this case, don't automatically add a link back to avoid duplication.
! 	if (!isset( $submenu[$parent_slug] ) && $menu_slug != $parent_slug  ) {
  		foreach ( (array)$menu as $parent_menu ) {
  			if ( $parent_menu[2] == $parent_slug && current_user_can( $parent_menu[1] ) )
  				$submenu[$parent_slug][] = $parent_menu;
--- 1010,1019 ----
  	}
  
  	// If the parent doesn't already have a submenu, add a link to the parent
! 	// as the first item in the submenu. If the submenu file is the same as the
! 	// parent file someone is trying to link back to the parent manually. In
  	// this case, don't automatically add a link back to avoid duplication.
! 	if (!isset( $submenu[$parent_slug] ) && $menu_slug != $parent_slug ) {
  		foreach ( (array)$menu as $parent_menu ) {
  			if ( $parent_menu[2] == $parent_slug && current_user_can( $parent_menu[1] ) )
  				$submenu[$parent_slug][] = $parent_menu;
***************
*** 1002,1008 ****
  		add_action( $hookname, $function );
  
  	$_registered_pages[$hookname] = true;
! 	// backwards-compatibility for plugins using add_management page.  See wp-admin/admin.php for redirect from edit.php to tools.php
  	if ( 'tools.php' == $parent_slug )
  		$_registered_pages[get_plugin_page_hookname( $menu_slug, 'edit.php')] = true;
  
--- 1027,1033 ----
  		add_action( $hookname, $function );
  
  	$_registered_pages[$hookname] = true;
! 	// backwards-compatibility for plugins using add_management page. See wp-admin/admin.php for redirect from edit.php to tools.php
  	if ( 'tools.php' == $parent_slug )
  		$_registered_pages[get_plugin_page_hookname( $menu_slug, 'edit.php')] = true;
  
***************
*** 1589,1595 ****
   *
   * @since 2.7.0
   *
!  * @param string $option_group A settings group name.  Should correspond to a whitelisted option key name.
   * 	Default whitelisted option key names include "general," "discussion," and "reading," among others.
   * @param string $option_name The name of an option to sanitize and save.
   * @param unknown_type $sanitize_callback A callback function that sanitizes the option's value.
--- 1613,1619 ----
   *
   * @since 2.7.0
   *
!  * @param string $option_group A settings group name. Should correspond to a whitelisted option key name.
   * 	Default whitelisted option key names include "general," "discussion," and "reading," among others.
   * @param string $option_name The name of an option to sanitize and save.
   * @param unknown_type $sanitize_callback A callback function that sanitizes the option's value.
***************
*** 1715,1726 ****
   *
   * @since 2.7.0
   *
!  * @param string $option_group A settings group name.  This should match the group name used in register_setting().
   */
  function settings_fields($option_group) {
  	echo "<input type='hidden' name='option_page' value='" . esc_attr($option_group) . "' />";
  	echo '<input type="hidden" name="action" value="update" />';
  	wp_nonce_field("$option_group-options");
  }
- 
- ?>
--- 1739,1748 ----
   *
   * @since 2.7.0
   *
!  * @param string $option_group A settings group name. This should match the group name used in register_setting().
   */
  function settings_fields($option_group) {
  	echo "<input type='hidden' name='option_page' value='" . esc_attr($option_group) . "' />";
  	echo '<input type="hidden" name="action" value="update" />';
  	wp_nonce_field("$option_group-options");
  }
